#include <iostream>

using namespace std;

// Primero implemento la clase que representa al Objeto Funcion que
// multiplica por una constante
class Multiplica {

public:

  Multiplica (double val = 1);
  double operator () (double x) const;

private:

  double k;

};

Multiplica::Multiplica (double val) : k(val) {
}

double Multiplica::operator () (double x) const {
  return x * k;
}


// Ahora implemento una funcion que recibe un array de double, el tamano
// del array y el objeto funcion que se va a aplicar a cada elemento del array
void transform (double* arr, int tam, const Multiplica& mult) {
  for (int i = 0; i < tam; i++)
    arr[i] = mult (arr[i]);
}

int main (void) {

  // Creo un array de double y lo relleno con numeros del 1 al 10
  double arr[10];

  for (int i = 0; i < 10; i++)
    arr[i] = i+1;

  cout << "Mi array es: ";
  for (int i = 0; i < 10; i++)
    cout << arr[i] << " ";
  cout << endl;

  // Creo un objeto funcion que me va a multiplicar por 3
  Multiplica mult (3);

  // Ahora invoco a la funcion que recorre el array y le aplica a cada elemento
  // el objeto funcion multiplicar por tres
  transform (arr, 10, mult);

  cout << "Mi array transformado es: ";
  for (int i = 0; i < 10; i++)
    cout << arr[i] << " ";
  cout << endl;

  return 0;

}
